// SockDemo.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <winplcrt.h>
#include <winsock.h>

/*
** SockDemo
**
** Demonstrates creation and use of a client side UDP socket. For TCP, use the socket() call
** that is commented out. Use this code as a starting point for adding TCP/IP functionality.
** 
**
*/

#define TARGET_ADDRESS	"192.168.0.111"	// Put the target address or host name here

void ODS(PCWSTR str)
{
	OutputDebugString(str);
	Sleep(10);
}

void ODS1(PCWSTR str, DWORD parm)
{
	WCHAR str2[100];
	wsprintf(str2, str, parm);
	ODS(str2);
}

void ODS2(PCWSTR str, DWORD parm1, DWORD parm2)
{
	WCHAR str2[100];
	wsprintf(str2, str, parm1, parm2);
	ODS(str2);
}

PCWSTR ToWide(LPCSTR pIn)
{
	static WCHAR Out[100];
	mbstowcs(Out, pIn, strlen(pIn));
	return Out;
}

LPCSTR ToNarrow(PCWSTR pIn)
{
	static char Out[100];
	wcstombs(Out, pIn, wcslen(pIn));
	return Out;
}

BOOL InitAddr(struct sockaddr_in *pRemoteAddr, PCWSTR pRemoteHostName, WORD Port) 
{
	// Try as name
	struct hostent *pRemoteHost = gethostbyname(ToNarrow(pRemoteHostName));
	if(!pRemoteHost) 
		{
		// Try as address
		DWORD addr = inet_addr(ToNarrow(pRemoteHostName));
		if(addr != INADDR_NONE)
			{
			pRemoteHost = gethostbyaddr((char *)&addr, 4, AF_INET);
			}
		}

	if(!pRemoteHost)
		{
		ODS1(TEXT("Error %d getting remote host information."), GetLastError());
		return FALSE;
		}

	memset(pRemoteAddr, 0, sizeof(*pRemoteAddr));
	pRemoteAddr->sin_family = AF_INET;
	pRemoteAddr->sin_port = htons(Port);
	pRemoteAddr->sin_addr = *(struct in_addr *)(pRemoteHost->h_addr_list[0]);
	return TRUE;
}


SOCKET CreateSocket()
{
//	SOCKET sSock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	SOCKET sSock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	if(sSock == INVALID_SOCKET)
		{
		ODS1(TEXT("Error %d creating socket."), GetLastError());
		return INVALID_SOCKET;
		}
	else
		return sSock;
}

BOOL DestroySocket(SOCKET sSock)
{
	if(closesocket(sSock) == SOCKET_ERROR)
		{
		ODS1(TEXT("Error %d closing socket."), GetLastError());
		return FALSE;
		}
	else
		{
		return TRUE;
		}
}

BOOL OpenConnection(SOCKET sSock, PCWSTR pHostName, WORD Port)
{
	sockaddr_in Addr;

	memset(&Addr, 0, sizeof(Addr));
	Addr.sin_family = AF_INET;
	Addr.sin_port = 0;
	Addr.sin_addr.S_un.S_addr = INADDR_ANY;

	if(bind(sSock, (const struct sockaddr *)&Addr, sizeof(Addr)))
		{
		ODS1(TEXT("Error %d binding socket."), GetLastError());
		return FALSE;
		}

	if(!InitAddr(&Addr, pHostName, Port))
		return FALSE;

	if(connect(sSock, (const struct sockaddr *)&Addr, sizeof(Addr)) == SOCKET_ERROR)
		{
		ODS1(TEXT("Error %d connecting to remote host."), GetLastError());
		return FALSE;
		}

	return TRUE;
}

BOOL SendString(SOCKET sSock, PCWSTR pStr)
{
	if(send(sSock, ToNarrow(pStr), wcslen(pStr)+1, 0) == SOCKET_ERROR)
		{
		ODS1(TEXT("Error %d sending string."), GetLastError());
		return FALSE;
		}
	else return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	ODS(TEXT("SockDemo started!"));

	SOCKET sSock = CreateSocket();
	if(sSock != INVALID_SOCKET)
		{
		if(OpenConnection(sSock, TEXT(TARGET_ADDRESS), 0x7272))
			SendString(sSock, TEXT("Hello, from the WinPLC"));

		DestroySocket(sSock);
		}

	ODS(TEXT("SockDemo exiting. Bye!"));
	return 0;
}

